#   Wrapper for the system call handler (we could have written the handler in
#   assembly)
#   %edi contains the function number (first parameter to syscall_handler)
#   %esi contains the argument value (second parameter to syscall_handler)

.text
	.align 4
.globl syscalls_handler_wrapper
	.type	 syscalls_handler_wrapper,@function
syscalls_handler_wrapper:
	subl	$4, %esp
	pusha			 # save registers (which ones ?) on the stack 
	pushl	%ds
	pushl	%es
	pushl	%fs
	pushl	%gs

   	# set the segment regs
	movl	$0x18, %eax
   	movl	%eax, %ds
	movl	%eax, %es		
	movl	%eax, %fs
	movl	%eax, %gs
      
   
	# save cr0
	movl	%cr0, %eax
	pushl	 %eax
	
	pushl	%esi
	pushl	%edi			
	call	syscalls_handler # call the C handler
	addl    $8, %esp	 # remove parameters

	# Put back cr0
	popl	%eax
	movl	%eax, %cr0
	
	popl	%gs
	popl	%fs
	popl	%es
	popl	%ds
	popa			 # restore the registers
	addl	$4, %esp
	iret			 # return from interrupt handler

